using System;

public class FactorialTest
{
	private delegate int Factorial(int n);
	
	public static void Main(string[]  args)
	{
		System.Console.WriteLine("Factorial recursive and iterative");
		System.Console.WriteLine("---------------------------------" + System.Environment.NewLine);
		
		for(int i = 1; i < 5; i++)
		{
			System.Console.WriteLine(string.Format("{0}!", (int)Math.Pow(10, i)));
			
			RunFactorial(i, FactorialRecursive, "Recursive");
			RunFactorial(i, FactorialIterative, "Iterative");
			System.Console.WriteLine();
		}
	}
	
	private static void RunFactorial(int i, Factorial fn, string name)
	{
		DateTime start;
		DateTime stop;
		TimeSpan diff;
		
		start = DateTime.Now;
		
		for(int j = 0; j < 1000000; j++)
		{
			fn((int)Math.Pow(10, i));
		}
		
		stop = DateTime.Now;
		
		diff = stop - start;
		System.Console.WriteLine(string.Format("{0}: {1}", name, diff));
	}
	
	private static int FactorialIterative(int n)
	{
		int localFactorial = 1;
		while(n > 1)
		{
			localFactorial *= n;
			n--;
		}
		
		return localFactorial;
	}
	
	private static int FactorialRecursive(int n)
	{
		if(n < 1) return 1;
		return n * FactorialRecursive(n -1);
	}
}
